c      beam-beam kick at IP
c    
       subroutine bbkickysuper

c
c      needs number of steps
c      needs length of detector
c
c
c

         INCLUDE 'param.f'

c      first go back from IP to start of interaction region

       do i = 1, npart 
       x(i) = x(i)-dlint*px(i) 
       y(i) = y(i)-dlint*py(i) 
       end do 

c      loop in steps through the interaction

       stepsize = (2.*dlint/real(nstep))

       do j = 0, nstep
       sinst = -dlint+real(j)*stepsize
       betainst = betastar+sinst*sinst/betastar
       sigmainst2 = 2.*betainst*emit

       acccoef=4.*dlambda*rp/gamma*(1.+cos(thetac))/2.
       ct = cos(thetac)
       st = sin(thetac)

       do i = 1, npart

       if (iwire45.eq.1) then
       u = (y(i)-x(i))/sqrt(2.d0)
       v = (y(i)+x(i))/sqrt(2.d0)  
       uscomb = (u*ct-sinst*st)
       uscomb0 = (-sinst*st)
       accy = acccoef*(uscomb+v)/(uscomb**2+v**2)*
     &        (1.-dexp(-uscomb**2/sigmainst2))/sqrt(2.)
       if (abs(uscomb0).gt.1.e-15) then
       accy0 = acccoef/(uscomb0)*
     &        (1.-dexp(-uscomb0**2/sigmainst2))/sqrt(2.)
       else
       accy0 = 0.
       endif
       accx = -acccoef*(uscomb-v)/(uscomb**2+v**2)*
     &        (1.-dexp(-uscomb**2/sigmainst2))/sqrt(2.)
       if (abs(uscomb0).gt.1.e-15) then
       accx0 = -acccoef/(uscomb0)*
     &        (1.-dexp(-uscomb0**2/sigmainst2))/sqrt(2.)
       else
       accx0 = 0.
       endif
       else 
       uscomb = (y(i)*ct-sinst*st)
       uscomb0 = (-sinst*st)
       accy = acccoef*(uscomb)/(uscomb**2+x(i)**2)*
     &        (1.-dexp(-uscomb**2/sigmainst2))
       if (abs(uscomb0).gt.1.e-15) then
       accy0 = acccoef/(uscomb0)*
     &        (1.-dexp(-uscomb0**2/sigmainst2))
       else
       accy0 = 0.
       endif 
       accx = acccoef*(x(i))/(uscomb**2+x(i)**2)*
     &        (1.-dexp(-uscomb**2/sigmainst2))
       accx0 = 0.
       endif

       pxo = px(i)
       pyo = py(i)
       px(i) = px(i)+(accx-accx0)*stepsize
       py(i) = py(i)+(accy-accy0)*stepsize
       x(i) = x(i)+stepsize*(px(i)+pxo)/2. 
       y(i) = y(i)+stepsize*(py(i)+pyo)/2. 
       enddo 

       enddo 

c      then go back from end of interaction region to IP

       do i = 1, npart 
       x(i) = x(i)-dlint*px(i) 
       y(i) = y(i)-dlint*py(i) 
       end do 

       end






