c     long range bb kick, all parasitic
c     crossings lumped together, constant
c     term subtracted, a la Irwin  
c     analogous to kicklr.f but for a
c     vertical parasitic crossing

      subroutine kicklry(pxt,pyt,xt,yt,dx,dy,dpx,dpy,ind)

c     input : pxt, pyt
c     output : dx, dy

       INCLUDE 'param.f'

      dx = 0.
      dy = 0.
      dpx = 0.
      dpy = 0.

      if (iwire45.eq.0) then
      pr2 = pxt*pxt+(pyt+thetac)**2 
      pr20 = thetac*thetac
      else     
      pr2 = (pxt-thetac/sqrt(2.))**2+(pyt+thetac/sqrt(2.))**2 
      pr20 = thetac*thetac
      endif 

      denom = 2.*divstar*divstar

      if (iwire.eq.1) then
      coefwire0 = coefwire*(1.+wrandom*2.*(ran2(idum)-0.5))
      endif

      if (iwire.eq.0.and.iwire45.eq.0) then
      dx = npar*srparam*(pxt/pr2*(1.d0-
     &      dexp(-pr2/denom)))
      dy = npar*srparam*((pyt+thetac)/pr2*(1.d0-
     &      dexp(-pr2/denom))
     &      -thetac/pr20*(1.d0-dexp(-pr20/denom)))  
      dpx = 0.
      dpy = 0.
      else if (iwire.eq.0.and.iwire45.eq.1) then
      dx = npar*srparam*((pxt-thetac/sqrt(2.))/pr2*(1.d0-
     &      dexp(-pr2/denom))
     &      +thetac/sqrt(2.)/pr20*(1.d0-dexp(-pr20/denom)))  
      dy = npar*srparam*((pyt+thetac/sqrt(2.))/pr2*(1.d0-
     &      dexp(-pr2/denom))
     &      -thetac/sqrt(2.)/pr20*(1.d0-dexp(-pr20/denom)))  
      dpx = 0.
      dpy = 0.

      else if (iwire.eq.1.and.iwswitch.eq.1.and.
     &         ind.eq.2.and.iwire45.eq.0) then

      dy = npar*srparam*((pyt+thetac)/pr2*(1.d0-
     &      dexp(-pr2/denom))
     &      -thetac/pr20*(1.d0-dexp(-pr20/denom))) 

      dx = npar*srparam*(pxt/pr2*(1.d0-
     &      dexp(-pr2/denom)))
 
      dpx = 0.
      dpy = 0.

      else if (iwire.eq.1.and.(iwswitch.ne.1.or.ind.ne.2))
     &     then

        if (ind.eq.1) then

c      write(*,*) ' lr y 1 '    

      pr2 = pxt*pxt+(pyt+thetac)**2 
      pr2w = (pxt+wpherr*xt/betastar)**2+(pyt+
     &        wpherr*yt/betastar+thetac*wdist)**2 
      pr2w0 = (thetac*wdist)**2

      denom = 2.*divstar*divstar

      dy = npar*srparam*((pyt+thetac)/pr2*(1.d0-
     &      dexp(-pr2/denom))
     &      -thetac/pr20*(1.d0-dexp(-pr20/denom))) 

      dx = npar*srparam*(pxt/pr2*(1.d0-
     &      dexp(-pr2/denom)))

      dyw = -coefwire0*((pyt+wpherr*yt/betastar+
     &      thetac*wdist)/pr2w)+
     &      coefwire*(thetac*wdist/pr2w0)

      dxw = -coefwire0*(pxt+wpherr*xt/betastar)/pr2w

      if (iwswitch.eq.1) then 
        dxw=dxw*2.
        dyw=dyw*2.
      endif

      dpx = -wpherr*dxw/betastar
      dpy = -wpherr*dyw/betastar

      dy = dy+dyw
      dx = dx+dxw     

      else if (ind.eq.2) then

c      write(*,*) ' lr y 2 '    

      pr2 = pxt*pxt+(pyt+thetac)**2 
      pr2w = (pxt-wpherr*xt/betastar)**2+(pyt-
     &       wpherr*yt/betastar+thetac*wdist)**2 
      pr2w0 = (thetac*wdist)**2

      denom = 2.*divstar*divstar

      dy = npar*srparam*((pyt+thetac)/pr2*(1.d0-
     &     dexp(-pr2/denom))
     &     -thetac/pr20*(1.d0-dexp(-pr20/denom))) 

      dyw = -coefwire0*((pyt-wpherr*yt/betastar+
     &     thetac*wdist)/pr2w)
     &     +coefwire*(thetac*wdist/pr2w0)

      dx = npar*srparam*(pxt/pr2*(1.d0-
     &     dexp(-pr2/denom)))
      dxw = -coefwire0*(pxt-wpherr*xt/betastar)/pr2w

      dpx = wpherr*dxw/betastar
      dpy = wpherr*dyw/betastar

      dx = dx+dxw
      dy = dx+dyw

      endif 

      endif 

      return
      end 


